]> git.notmuchmail.org Git - notmuch/blob - test/test-lib.sh
test: unset 'xpg_echo' bash shell option
[notmuch] / test / test-lib.sh
1 #
2 # Copyright (c) 2005 Junio C Hamano
3 #
4 # This program is free software: you can redistribute it and/or modify
5 # it under the terms of the GNU General Public License as published by
6 # the Free Software Foundation, either version 2 of the License, or
7 # (at your option) any later version.
8 #
9 # This program is distributed in the hope that it will be useful,
10 # but WITHOUT ANY WARRANTY; without even the implied warranty of
11 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
12 # GNU General Public License for more details.
13 #
14 # You should have received a copy of the GNU General Public License
15 # along with this program.  If not, see http://www.gnu.org/licenses/ .
16
17 if [ ${BASH_VERSINFO[0]} -lt 4 ]; then
18     echo "Error: The notmuch test suite requires a bash version >= 4.0"
19     echo "due to use of associative arrays within the test suite."
20     echo "Please try again with a newer bash (or help us fix the"
21     echo "test suite to be more portable). Thanks."
22     exit 1
23 fi
24
25 # Make sure echo builtin does not expand backslash-escape sequences by default.
26 shopt -u xpg_echo
27
28 # if --tee was passed, write the output not only to the terminal, but
29 # additionally to the file test-results/$BASENAME.out, too.
30 case "$GIT_TEST_TEE_STARTED, $* " in
31 done,*)
32         # do not redirect again
33         ;;
34 *' --tee '*|*' --va'*)
35         mkdir -p test-results
36         BASE=test-results/$(basename "$0" .sh)
37         (GIT_TEST_TEE_STARTED=done ${SHELL-sh} "$0" "$@" 2>&1;
38          echo $? > $BASE.exit) | tee $BASE.out
39         test "$(cat $BASE.exit)" = 0
40         exit
41         ;;
42 esac
43
44 # Keep the original TERM for say_color and test_emacs
45 ORIGINAL_TERM=$TERM
46
47 # dtach(1) provides more capable terminal environment to anything
48 # that requires more than dumb terminal...
49 [ x"${TERM:-dumb}" = xdumb ] && DTACH_TERM=vt100 || DTACH_TERM=$TERM
50
51 # For repeatability, reset the environment to known value.
52 LANG=C
53 LC_ALL=C
54 PAGER=cat
55 TZ=UTC
56 TERM=dumb
57 export LANG LC_ALL PAGER TERM TZ
58 GIT_TEST_CMP=${GIT_TEST_CMP:-diff -u}
59 if [[ ( -n "$TEST_EMACS" && -z "$TEST_EMACSCLIENT" ) || \
60       ( -z "$TEST_EMACS" && -n "$TEST_EMACSCLIENT" ) ]]; then
61     echo "error: must specify both or neither of TEST_EMACS and TEST_EMACSCLIENT" >&2
62     exit 1
63 fi
64 TEST_EMACS=${TEST_EMACS:-${EMACS:-emacs}}
65 TEST_EMACSCLIENT=${TEST_EMACSCLIENT:-emacsclient}
66
67 # Protect ourselves from common misconfiguration to export
68 # CDPATH into the environment
69 unset CDPATH
70
71 unset GREP_OPTIONS
72
73 # Convenience
74 #
75 # A regexp to match 5 and 40 hexdigits
76 _x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
77 _x40="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
78
79 _x04='[0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
80 _x32="$_x04$_x04$_x04$_x04$_x04$_x04$_x04$_x04"
81
82 # Each test should start with something like this, after copyright notices:
83 #
84 # test_description='Description of this test...
85 # This test checks if command xyzzy does the right thing...
86 # '
87 # . ./test-lib.sh
88 [ "x$ORIGINAL_TERM" != "xdumb" ] && (
89                 TERM=$ORIGINAL_TERM &&
90                 export TERM &&
91                 [ -t 1 ] &&
92                 tput bold >/dev/null 2>&1 &&
93                 tput setaf 1 >/dev/null 2>&1 &&
94                 tput sgr0 >/dev/null 2>&1
95         ) &&
96         color=t
97
98 while test "$#" -ne 0
99 do
100         case "$1" in
101         -d|--d|--de|--deb|--debu|--debug)
102                 debug=t; shift ;;
103         -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
104                 immediate=t; shift ;;
105         -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
106                 GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
107         -h|--h|--he|--hel|--help)
108                 help=t; shift ;;
109         -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
110                 verbose=t; shift ;;
111         -q|--q|--qu|--qui|--quie|--quiet)
112                 quiet=t; shift ;;
113         --with-dashes)
114                 with_dashes=t; shift ;;
115         --no-color)
116                 color=; shift ;;
117         --no-python)
118                 # noop now...
119                 shift ;;
120         --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
121                 valgrind=t; verbose=t; shift ;;
122         --tee)
123                 shift ;; # was handled already
124         --root=*)
125                 root=$(expr "z$1" : 'z[^=]*=\(.*\)')
126                 shift ;;
127         *)
128                 echo "error: unknown test option '$1'" >&2; exit 1 ;;
129         esac
130 done
131
132 if test -n "$debug"; then
133     print_subtest () {
134         printf " %-4s" "[$((test_count - 1))]"
135     }
136 else
137     print_subtest () {
138         true
139     }
140 fi
141
142 if test -n "$color"; then
143         say_color () {
144                 (
145                 TERM=$ORIGINAL_TERM
146                 export TERM
147                 case "$1" in
148                         error) tput bold; tput setaf 1;; # bold red
149                         skip)  tput bold; tput setaf 2;; # bold green
150                         pass)  tput setaf 2;;            # green
151                         info)  tput setaf 3;;            # brown
152                         *) test -n "$quiet" && return;;
153                 esac
154                 shift
155                 printf " "
156                 printf "$@"
157                 tput sgr0
158                 print_subtest
159                 )
160         }
161 else
162         say_color() {
163                 test -z "$1" && test -n "$quiet" && return
164                 shift
165                 printf " "
166                 printf "$@"
167                 print_subtest
168         }
169 fi
170
171 error () {
172         say_color error "error: $*\n"
173         GIT_EXIT_OK=t
174         exit 1
175 }
176
177 say () {
178         say_color info "$*"
179 }
180
181 test "${test_description}" != "" ||
182 error "Test script did not set test_description."
183
184 if test "$help" = "t"
185 then
186         echo "Tests ${test_description}"
187         exit 0
188 fi
189
190 echo $(basename "$0"): "Testing ${test_description}"
191
192 exec 5>&1
193
194 test_failure=0
195 test_count=0
196 test_fixed=0
197 test_broken=0
198 test_success=0
199
200 _die_common () {
201         code=$?
202         trap - EXIT
203         set +ex
204         rm -rf "$TEST_TMPDIR"
205 }
206
207 die () {
208         _die_common
209         if test -n "$GIT_EXIT_OK"
210         then
211                 exit $code
212         else
213                 exec >&5
214                 say_color error '%-6s' FATAL
215                 echo " $test_subtest_name"
216                 echo
217                 echo "Unexpected exit while executing $0. Exit code $code."
218                 exit 1
219         fi
220 }
221
222 die_signal () {
223         _die_common
224         echo >&5 "FATAL: $0: interrupted by signal" $((code - 128))
225         exit $code
226 }
227
228 GIT_EXIT_OK=
229 # Note: TEST_TMPDIR *NOT* exported!
230 TEST_TMPDIR=$(mktemp -d "${TMPDIR:-/tmp}/notmuch-test-$$.XXXXXX")
231 trap 'die' EXIT
232 trap 'die_signal' HUP INT TERM
233
234 test_decode_color () {
235         sed     -e 's/.\[1m/<WHITE>/g' \
236                 -e 's/.\[31m/<RED>/g' \
237                 -e 's/.\[32m/<GREEN>/g' \
238                 -e 's/.\[33m/<YELLOW>/g' \
239                 -e 's/.\[34m/<BLUE>/g' \
240                 -e 's/.\[35m/<MAGENTA>/g' \
241                 -e 's/.\[36m/<CYAN>/g' \
242                 -e 's/.\[m/<RESET>/g'
243 }
244
245 q_to_nul () {
246         perl -pe 'y/Q/\000/'
247 }
248
249 q_to_cr () {
250         tr Q '\015'
251 }
252
253 append_cr () {
254         sed -e 's/$/Q/' | tr Q '\015'
255 }
256
257 remove_cr () {
258         tr '\015' Q | sed -e 's/Q$//'
259 }
260
261 # Generate a new message in the mail directory, with a unique message
262 # ID and subject. The message is not added to the index.
263 #
264 # After this function returns, the filename of the generated message
265 # is available as $gen_msg_filename and the message ID is available as
266 # $gen_msg_id .
267 #
268 # This function supports named parameters with the bash syntax for
269 # assigning a value to an associative array ([name]=value). The
270 # supported parameters are:
271 #
272 #  [dir]=directory/of/choice
273 #
274 #       Generate the message in directory 'directory/of/choice' within
275 #       the mail store. The directory will be created if necessary.
276 #
277 #  [filename]=name
278 #
279 #       Store the message in file 'name'. The default is to store it
280 #       in 'msg-<count>', where <count> is three-digit number of the
281 #       message.
282 #
283 #  [body]=text
284 #
285 #       Text to use as the body of the email message
286 #
287 #  '[from]="Some User <user@example.com>"'
288 #  '[to]="Some User <user@example.com>"'
289 #  '[subject]="Subject of email message"'
290 #  '[date]="RFC 822 Date"'
291 #
292 #       Values for email headers. If not provided, default values will
293 #       be generated instead.
294 #
295 #  '[cc]="Some User <user@example.com>"'
296 #  [reply-to]=some-address
297 #  [in-reply-to]=<message-id>
298 #  [references]=<message-id>
299 #  [content-type]=content-type-specification
300 #  '[header]=full header line, including keyword'
301 #
302 #       Additional values for email headers. If these are not provided
303 #       then the relevant headers will simply not appear in the
304 #       message.
305 #
306 #  '[id]=message-id'
307 #
308 #       Controls the message-id of the created message.
309 gen_msg_cnt=0
310 gen_msg_filename=""
311 gen_msg_id=""
312 generate_message ()
313 {
314     # This is our (bash-specific) magic for doing named parameters
315     local -A template="($@)"
316     local additional_headers
317
318     gen_msg_cnt=$((gen_msg_cnt + 1))
319     if [ -z "${template[filename]}" ]; then
320         gen_msg_name="msg-$(printf "%03d" $gen_msg_cnt)"
321     else
322         gen_msg_name=${template[filename]}
323     fi
324
325     if [ -z "${template[id]}" ]; then
326         gen_msg_id="${gen_msg_name%:2,*}@notmuch-test-suite"
327     else
328         gen_msg_id="${template[id]}"
329     fi
330
331     if [ -z "${template[dir]}" ]; then
332         gen_msg_filename="${MAIL_DIR}/$gen_msg_name"
333     else
334         gen_msg_filename="${MAIL_DIR}/${template[dir]}/$gen_msg_name"
335         mkdir -p "$(dirname "$gen_msg_filename")"
336     fi
337
338     if [ -z "${template[body]}" ]; then
339         template[body]="This is just a test message (#${gen_msg_cnt})"
340     fi
341
342     if [ -z "${template[from]}" ]; then
343         template[from]="Notmuch Test Suite <test_suite@notmuchmail.org>"
344     fi
345
346     if [ -z "${template[to]}" ]; then
347         template[to]="Notmuch Test Suite <test_suite@notmuchmail.org>"
348     fi
349
350     if [ -z "${template[subject]}" ]; then
351         if [ -n "$test_subtest_name" ]; then
352             template[subject]="$test_subtest_name"
353         else
354             template[subject]="Test message #${gen_msg_cnt}"
355         fi
356     fi
357
358     if [ -z "${template[date]}" ]; then
359         template[date]="Fri, 05 Jan 2001 15:43:57 +0000"
360     fi
361
362     additional_headers=""
363     if [ ! -z "${template[header]}" ]; then
364         additional_headers="${template[header]}
365 ${additional_headers}"
366     fi
367
368     if [ ! -z "${template[reply-to]}" ]; then
369         additional_headers="Reply-To: ${template[reply-to]}
370 ${additional_headers}"
371     fi
372
373     if [ ! -z "${template[in-reply-to]}" ]; then
374         additional_headers="In-Reply-To: ${template[in-reply-to]}
375 ${additional_headers}"
376     fi
377
378     if [ ! -z "${template[cc]}" ]; then
379         additional_headers="Cc: ${template[cc]}
380 ${additional_headers}"
381     fi
382
383     if [ ! -z "${template[bcc]}" ]; then
384         additional_headers="Bcc: ${template[bcc]}
385 ${additional_headers}"
386     fi
387
388     if [ ! -z "${template[references]}" ]; then
389         additional_headers="References: ${template[references]}
390 ${additional_headers}"
391     fi
392
393     if [ ! -z "${template[content-type]}" ]; then
394         additional_headers="Content-Type: ${template[content-type]}
395 ${additional_headers}"
396     fi
397
398     if [ ! -z "${template[content-transfer-encoding]}" ]; then
399         additional_headers="Content-Transfer-Encoding: ${template[content-transfer-encoding]}
400 ${additional_headers}"
401     fi
402
403     # Note that in the way we're setting it above and using it below,
404     # `additional_headers' will also serve as the header / body separator
405     # (empty line in between).
406
407     cat <<EOF >"$gen_msg_filename"
408 From: ${template[from]}
409 To: ${template[to]}
410 Message-Id: <${gen_msg_id}>
411 Subject: ${template[subject]}
412 Date: ${template[date]}
413 ${additional_headers}
414 ${template[body]}
415 EOF
416 }
417
418 # Generate a new message and add it to the database.
419 #
420 # All of the arguments and return values supported by generate_message
421 # are also supported here, so see that function for details.
422 add_message ()
423 {
424     generate_message "$@" &&
425     notmuch new > /dev/null
426 }
427
428 # Deliver a message with emacs and add it to the database
429 #
430 # Uses emacs to generate and deliver a message to the mail store.
431 # Accepts arbitrary extra emacs/elisp functions to modify the message
432 # before sending, which is useful to doing things like attaching files
433 # to the message and encrypting/signing.
434 emacs_deliver_message ()
435 {
436     local subject="$1"
437     local body="$2"
438     shift 2
439     # before we can send a message, we have to prepare the FCC maildir
440     mkdir -p "$MAIL_DIR"/sent/{cur,new,tmp}
441     # eval'ing smtp-dummy --background will set smtp_dummy_pid
442     smtp_dummy_pid=
443     eval `$TEST_DIRECTORY/smtp-dummy --background sent_message`
444     test -n "$smtp_dummy_pid" || return 1
445
446     test_emacs \
447         "(let ((message-send-mail-function 'message-smtpmail-send-it)
448                (smtpmail-smtp-server \"localhost\")
449                (smtpmail-smtp-service \"25025\"))
450            (notmuch-hello)
451            (notmuch-mua-mail)
452            (message-goto-to)
453            (insert \"test_suite@notmuchmail.org\nDate: 01 Jan 2000 12:00:00 -0000\")
454            (message-goto-subject)
455            (insert \"${subject}\")
456            (message-goto-body)
457            (insert \"${body}\")
458            $@
459            (message-send-and-exit))"
460
461     # In case message was sent properly, client waits for confirmation
462     # before exiting and resuming control here; therefore making sure
463     # that server exits by sending (KILL) signal to it is safe.
464     kill -9 $smtp_dummy_pid
465     notmuch new >/dev/null
466 }
467
468 # Generate a corpus of email and add it to the database.
469 #
470 # This corpus is fixed, (it happens to be 50 messages from early in
471 # the history of the notmuch mailing list), which allows for reliably
472 # testing commands that need to operate on a not-totally-trivial
473 # number of messages.
474 add_email_corpus ()
475 {
476     rm -rf ${MAIL_DIR}
477     if [ -d $TEST_DIRECTORY/corpus.mail ]; then
478         cp -a $TEST_DIRECTORY/corpus.mail ${MAIL_DIR}
479     else
480         cp -a $TEST_DIRECTORY/corpus ${MAIL_DIR}
481         notmuch new >/dev/null
482         cp -a ${MAIL_DIR} $TEST_DIRECTORY/corpus.mail
483     fi
484 }
485
486 test_begin_subtest ()
487 {
488     if [ -n "$inside_subtest" ]; then
489         exec 1>&6 2>&7          # Restore stdout and stderr
490         error "bug in test script: Missing test_expect_equal in ${BASH_SOURCE[1]}:${BASH_LINENO[0]}"
491     fi
492     test_subtest_name="$1"
493     test_reset_state_
494     # Remember stdout and stderr file descriptors and redirect test
495     # output to the previously prepared file descriptors 3 and 4 (see
496     # below)
497     if test "$verbose" != "t"; then exec 4>test.output 3>&4; fi
498     exec 6>&1 7>&2 >&3 2>&4
499     inside_subtest=t
500 }
501
502 # Pass test if two arguments match
503 #
504 # Note: Unlike all other test_expect_* functions, this function does
505 # not accept a test name. Instead, the caller should call
506 # test_begin_subtest before calling this function in order to set the
507 # name.
508 test_expect_equal ()
509 {
510         exec 1>&6 2>&7          # Restore stdout and stderr
511         inside_subtest=
512         test "$#" = 3 && { prereq=$1; shift; } || prereq=
513         test "$#" = 2 ||
514         error "bug in the test script: not 2 or 3 parameters to test_expect_equal"
515
516         output="$1"
517         expected="$2"
518         if ! test_skip "$test_subtest_name"
519         then
520                 if [ "$output" = "$expected" ]; then
521                         test_ok_
522                 else
523                         testname=$this_test.$test_count
524                         echo "$expected" > $testname.expected
525                         echo "$output" > $testname.output
526                         test_failure_ "$(diff -u $testname.expected $testname.output)"
527                 fi
528     fi
529 }
530
531 # Like test_expect_equal, but takes two filenames.
532 test_expect_equal_file ()
533 {
534         exec 1>&6 2>&7          # Restore stdout and stderr
535         inside_subtest=
536         test "$#" = 3 && { prereq=$1; shift; } || prereq=
537         test "$#" = 2 ||
538         error "bug in the test script: not 2 or 3 parameters to test_expect_equal"
539
540         file1="$1"
541         basename1=`basename "$file1"`
542         file2="$2"
543         basename2=`basename "$file2"`
544         if ! test_skip "$test_subtest_name"
545         then
546                 if diff -q "$file1" "$file2" >/dev/null ; then
547                         test_ok_
548                 else
549                         testname=$this_test.$test_count
550                         cp "$file1" "$testname.$basename1"
551                         cp "$file2" "$testname.$basename2"
552                         test_failure_ "$(diff -u "$testname.$basename1" "$testname.$basename2")"
553                 fi
554     fi
555 }
556
557 # Like test_expect_equal, but arguments are JSON expressions to be
558 # canonicalized before diff'ing.  If an argument cannot be parsed, it
559 # is used unchanged so that there's something to diff against.
560 test_expect_equal_json () {
561     # The test suite forces LC_ALL=C, but this causes Python 3 to
562     # decode stdin as ASCII.  We need to read JSON in UTF-8, so
563     # override Python's stdio encoding defaults.
564     output=$(echo "$1" | PYTHONIOENCODING=utf-8 python -mjson.tool \
565         || echo "$1")
566     expected=$(echo "$2" | PYTHONIOENCODING=utf-8 python -mjson.tool \
567         || echo "$2")
568     shift 2
569     test_expect_equal "$output" "$expected" "$@"
570 }
571
572 test_emacs_expect_t () {
573         test "$#" = 2 && { prereq=$1; shift; } || prereq=
574         test "$#" = 1 ||
575         error "bug in the test script: not 1 or 2 parameters to test_emacs_expect_t"
576
577         # Run the test.
578         if ! test_skip "$test_subtest_name"
579         then
580                 test_emacs "(notmuch-test-run $1)" >/dev/null
581
582                 # Restore state after the test.
583                 exec 1>&6 2>&7          # Restore stdout and stderr
584                 inside_subtest=
585
586                 # Report success/failure.
587                 result=$(cat OUTPUT)
588                 if [ "$result" = t ]
589                 then
590                         test_ok_
591                 else
592                         test_failure_ "${result}"
593                 fi
594         else
595                 # Restore state after the (non) test.
596                 exec 1>&6 2>&7          # Restore stdout and stderr
597                 inside_subtest=
598         fi
599 }
600
601 NOTMUCH_NEW ()
602 {
603     notmuch new "${@}" | grep -v -E -e '^Processed [0-9]*( total)? file|Found [0-9]* total file'
604 }
605
606 notmuch_search_sanitize ()
607 {
608     perl -pe 's/("?thread"?: ?)("?)................("?)/\1\2XXX\3/'
609 }
610
611 NOTMUCH_SHOW_FILENAME_SQUELCH='s,filename:.*/mail,filename:/XXX/mail,'
612 notmuch_show_sanitize ()
613 {
614     sed -e "$NOTMUCH_SHOW_FILENAME_SQUELCH"
615 }
616 notmuch_show_sanitize_all ()
617 {
618     sed \
619         -e 's| filename:.*| filename:XXXXX|' \
620         -e 's| id:[^ ]* | id:XXXXX |'
621 }
622
623 notmuch_json_show_sanitize ()
624 {
625     sed \
626         -e 's|"id": "[^"]*",|"id": "XXXXX",|g' \
627         -e 's|"filename": "/[^"]*",|"filename": "YYYYY",|g'
628 }
629
630 # End of notmuch helper functions
631
632 # Use test_set_prereq to tell that a particular prerequisite is available.
633 # The prerequisite can later be checked for in two ways:
634 #
635 # - Explicitly using test_have_prereq.
636 #
637 # - Implicitly by specifying the prerequisite tag in the calls to
638 #   test_expect_{success,failure,code}.
639 #
640 # The single parameter is the prerequisite tag (a simple word, in all
641 # capital letters by convention).
642
643 test_set_prereq () {
644         satisfied="$satisfied$1 "
645 }
646 satisfied=" "
647
648 test_have_prereq () {
649         case $satisfied in
650         *" $1 "*)
651                 : yes, have it ;;
652         *)
653                 ! : nope ;;
654         esac
655 }
656
657 declare -A test_missing_external_prereq_
658 declare -A test_subtest_missing_external_prereq_
659
660 # declare prerequisite for the given external binary
661 test_declare_external_prereq () {
662         binary="$1"
663         test "$#" = 2 && name=$2 || name="$binary(1)"
664
665         if ! hash $binary 2>/dev/null; then
666                 test_missing_external_prereq_["${binary}"]=t
667                 eval "
668 $binary () {
669         test_subtest_missing_external_prereq_[\"${name}\"]=t
670         false
671 }"
672         fi
673 }
674
675 # Explicitly require external prerequisite.  Useful when binary is
676 # called indirectly (e.g. from emacs).
677 # Returns success if dependency is available, failure otherwise.
678 test_require_external_prereq () {
679         binary="$1"
680         if [[ ${test_missing_external_prereq_["${binary}"]} == t ]]; then
681                 # dependency is missing, call the replacement function to note it
682                 eval "$binary"
683         else
684                 true
685         fi
686 }
687
688 # You are not expected to call test_ok_ and test_failure_ directly, use
689 # the text_expect_* functions instead.
690
691 test_ok_ () {
692         if test "$test_subtest_known_broken_" = "t"; then
693                 test_known_broken_ok_
694                 return
695         fi
696         test_success=$(($test_success + 1))
697         say_color pass "%-6s" "PASS"
698         echo " $test_subtest_name"
699 }
700
701 test_failure_ () {
702         if test "$test_subtest_known_broken_" = "t"; then
703                 test_known_broken_failure_ "$@"
704                 return
705         fi
706         test_failure=$(($test_failure + 1))
707         test_failure_message_ "FAIL" "$test_subtest_name" "$@"
708         test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
709         return 1
710 }
711
712 test_failure_message_ () {
713         say_color error "%-6s" "$1"
714         echo " $2"
715         shift 2
716         echo "$@" | sed -e 's/^/        /'
717         if test "$verbose" != "t"; then cat test.output; fi
718 }
719
720 test_known_broken_ok_ () {
721         test_reset_state_
722         test_fixed=$(($test_fixed+1))
723         say_color pass "%-6s" "FIXED"
724         echo " $test_subtest_name"
725 }
726
727 test_known_broken_failure_ () {
728         test_reset_state_
729         test_broken=$(($test_broken+1))
730         test_failure_message_ "BROKEN" "$test_subtest_name" "$@"
731         return 1
732 }
733
734 test_debug () {
735         test "$debug" = "" || eval "$1"
736 }
737
738 test_run_ () {
739         test_cleanup=:
740         if test "$verbose" != "t"; then exec 4>test.output 3>&4; fi
741         eval >&3 2>&4 "$1"
742         eval_ret=$?
743         eval >&3 2>&4 "$test_cleanup"
744         return 0
745 }
746
747 test_skip () {
748         test_count=$(($test_count+1))
749         to_skip=
750         for skp in $NOTMUCH_SKIP_TESTS
751         do
752                 case $this_test.$test_count in
753                 $skp)
754                         to_skip=t
755                 esac
756         done
757         if test -z "$to_skip" && test -n "$prereq" &&
758            ! test_have_prereq "$prereq"
759         then
760                 to_skip=t
761         fi
762         case "$to_skip" in
763         t)
764                 test_report_skip_ "$@"
765                 ;;
766         *)
767                 test_check_missing_external_prereqs_ "$@"
768                 ;;
769         esac
770 }
771
772 test_check_missing_external_prereqs_ () {
773         if [[ ${#test_subtest_missing_external_prereq_[@]} != 0 ]]; then
774                 say_color skip >&1 "missing prerequisites: "
775                 echo ${!test_subtest_missing_external_prereq_[@]} >&1
776                 test_report_skip_ "$@"
777         else
778                 false
779         fi
780 }
781
782 test_report_skip_ () {
783         test_reset_state_
784         say_color skip >&3 "skipping test:"
785         echo " $@" >&3
786         say_color skip "%-6s" "SKIP"
787         echo " $1"
788 }
789
790 test_subtest_known_broken () {
791         test_subtest_known_broken_=t
792 }
793
794 test_expect_success () {
795         test "$#" = 3 && { prereq=$1; shift; } || prereq=
796         test "$#" = 2 ||
797         error "bug in the test script: not 2 or 3 parameters to test-expect-success"
798         test_subtest_name="$1"
799         test_reset_state_
800         if ! test_skip "$@"
801         then
802                 test_run_ "$2"
803                 run_ret="$?"
804                 # test_run_ may update missing external prerequisites
805                 test_check_missing_external_prereqs_ "$@" ||
806                 if [ "$run_ret" = 0 -a "$eval_ret" = 0 ]
807                 then
808                         test_ok_
809                 else
810                         test_failure_ "$2"
811                 fi
812         fi
813 }
814
815 test_expect_code () {
816         test "$#" = 4 && { prereq=$1; shift; } || prereq=
817         test "$#" = 3 ||
818         error "bug in the test script: not 3 or 4 parameters to test-expect-code"
819         test_subtest_name="$2"
820         test_reset_state_
821         if ! test_skip "$@"
822         then
823                 test_run_ "$3"
824                 run_ret="$?"
825                 # test_run_ may update missing external prerequisites,
826                 test_check_missing_external_prereqs_ "$@" ||
827                 if [ "$run_ret" = 0 -a "$eval_ret" = "$1" ]
828                 then
829                         test_ok_
830                 else
831                         test_failure_ "exit code $eval_ret, expected $1" "$3"
832                 fi
833         fi
834 }
835
836 # test_external runs external test scripts that provide continuous
837 # test output about their progress, and succeeds/fails on
838 # zero/non-zero exit code.  It outputs the test output on stdout even
839 # in non-verbose mode, and announces the external script with "* run
840 # <n>: ..." before running it.  When providing relative paths, keep in
841 # mind that all scripts run in "trash directory".
842 # Usage: test_external description command arguments...
843 # Example: test_external 'Perl API' perl ../path/to/test.pl
844 test_external () {
845         test "$#" = 4 && { prereq=$1; shift; } || prereq=
846         test "$#" = 3 ||
847         error >&5 "bug in the test script: not 3 or 4 parameters to test_external"
848         test_subtest_name="$1"
849         shift
850         test_reset_state_
851         if ! test_skip "$test_subtest_name" "$@"
852         then
853                 # Announce the script to reduce confusion about the
854                 # test output that follows.
855                 say_color "" " run $test_count: $descr ($*)"
856                 # Run command; redirect its stderr to &4 as in
857                 # test_run_, but keep its stdout on our stdout even in
858                 # non-verbose mode.
859                 "$@" 2>&4
860                 if [ "$?" = 0 ]
861                 then
862                         test_ok_
863                 else
864                         test_failure_ "$@"
865                 fi
866         fi
867 }
868
869 # Like test_external, but in addition tests that the command generated
870 # no output on stderr.
871 test_external_without_stderr () {
872         # The temporary file has no (and must have no) security
873         # implications.
874         tmp="$TMPDIR"; if [ -z "$tmp" ]; then tmp=/tmp; fi
875         stderr="$tmp/git-external-stderr.$$.tmp"
876         test_external "$@" 4> "$stderr"
877         [ -f "$stderr" ] || error "Internal error: $stderr disappeared."
878         test_subtest_name="no stderr: $1"
879         shift
880         if [ ! -s "$stderr" ]; then
881                 rm "$stderr"
882                 test_ok_
883         else
884                 if [ "$verbose" = t ]; then
885                         output=`echo; echo Stderr is:; cat "$stderr"`
886                 else
887                         output=
888                 fi
889                 # rm first in case test_failure exits.
890                 rm "$stderr"
891                 test_failure_ "$@" "$output"
892         fi
893 }
894
895 # This is not among top-level (test_expect_success)
896 # but is a prefix that can be used in the test script, like:
897 #
898 #       test_expect_success 'complain and die' '
899 #           do something &&
900 #           do something else &&
901 #           test_must_fail git checkout ../outerspace
902 #       '
903 #
904 # Writing this as "! git checkout ../outerspace" is wrong, because
905 # the failure could be due to a segv.  We want a controlled failure.
906
907 test_must_fail () {
908         "$@"
909         test $? -gt 0 -a $? -le 129 -o $? -gt 192
910 }
911
912 # test_cmp is a helper function to compare actual and expected output.
913 # You can use it like:
914 #
915 #       test_expect_success 'foo works' '
916 #               echo expected >expected &&
917 #               foo >actual &&
918 #               test_cmp expected actual
919 #       '
920 #
921 # This could be written as either "cmp" or "diff -u", but:
922 # - cmp's output is not nearly as easy to read as diff -u
923 # - not all diff versions understand "-u"
924
925 test_cmp() {
926         $GIT_TEST_CMP "$@"
927 }
928
929 # This function can be used to schedule some commands to be run
930 # unconditionally at the end of the test to restore sanity:
931 #
932 #       test_expect_success 'test core.capslock' '
933 #               git config core.capslock true &&
934 #               test_when_finished "git config --unset core.capslock" &&
935 #               hello world
936 #       '
937 #
938 # That would be roughly equivalent to
939 #
940 #       test_expect_success 'test core.capslock' '
941 #               git config core.capslock true &&
942 #               hello world
943 #               git config --unset core.capslock
944 #       '
945 #
946 # except that the greeting and config --unset must both succeed for
947 # the test to pass.
948
949 test_when_finished () {
950         test_cleanup="{ $*
951                 } && (exit \"\$eval_ret\"); eval_ret=\$?; $test_cleanup"
952 }
953
954 test_done () {
955         GIT_EXIT_OK=t
956         test_results_dir="$TEST_DIRECTORY/test-results"
957         mkdir -p "$test_results_dir"
958         test_results_path="$test_results_dir/${0%.sh}"
959
960         echo "total $test_count" >> $test_results_path
961         echo "success $test_success" >> $test_results_path
962         echo "fixed $test_fixed" >> $test_results_path
963         echo "broken $test_broken" >> $test_results_path
964         echo "failed $test_failure" >> $test_results_path
965         echo "" >> $test_results_path
966
967         echo
968
969         [ -n "$EMACS_SERVER" ] && test_emacs '(kill-emacs)'
970
971         if [ "$test_failure" = "0" ]; then
972             if [ "$test_broken" = "0" ]; then
973                 rm -rf "$remove_tmp"
974             fi
975             exit 0
976         else
977             exit 1
978         fi
979 }
980
981 emacs_generate_script () {
982         # Construct a little test script here for the benefit of the user,
983         # (who can easily run "run_emacs" to get the same emacs environment
984         # for investigating any failures).
985         cat <<EOF >"$TMP_DIRECTORY/run_emacs"
986 #!/bin/sh
987 export PATH=$PATH
988 export NOTMUCH_CONFIG=$NOTMUCH_CONFIG
989
990 # Here's what we are using here:
991 #
992 # --no-init-file        Don't load users ~/.emacs
993 #
994 # --no-site-file        Don't load the site-wide startup stuff
995 #
996 # --directory           Ensure that the local elisp sources are found
997 #
998 # --load                Force loading of notmuch.el and test-lib.el
999
1000 exec ${TEST_EMACS} --no-init-file --no-site-file \
1001         --directory "$TEST_DIRECTORY/../emacs" --load notmuch.el \
1002         --directory "$TEST_DIRECTORY" --load test-lib.el \
1003         "\$@"
1004 EOF
1005         chmod a+x "$TMP_DIRECTORY/run_emacs"
1006 }
1007
1008 test_emacs () {
1009         # test dependencies beforehand to avoid the waiting loop below
1010         missing_dependencies=
1011         test_require_external_prereq dtach || missing_dependencies=1
1012         test_require_external_prereq emacs || missing_dependencies=1
1013         test_require_external_prereq ${TEST_EMACSCLIENT} || missing_dependencies=1
1014         test -z "$missing_dependencies" || return
1015
1016         if [ -z "$EMACS_SERVER" ]; then
1017                 emacs_tests="$(basename $0).el"
1018                 if [ -f "$TEST_DIRECTORY/$emacs_tests" ]; then
1019                         load_emacs_tests="--eval '(load \"$emacs_tests\")'"
1020                 else
1021                         load_emacs_tests=
1022                 fi
1023                 server_name="notmuch-test-suite-$$"
1024                 # start a detached session with an emacs server
1025                 # user's TERM (or 'vt100' in case user's TERM is unset, empty
1026                 # or 'dumb') is given to dtach which assumes a minimally
1027                 # VT100-compatible terminal -- and emacs inherits that
1028                 TERM=$DTACH_TERM dtach -n "$TEST_TMPDIR/emacs-dtach-socket.$$" \
1029                         sh -c "stty rows 24 cols 80; exec '$TMP_DIRECTORY/run_emacs' \
1030                                 --no-window-system \
1031                                 $load_emacs_tests \
1032                                 --eval '(setq server-name \"$server_name\")' \
1033                                 --eval '(server-start)' \
1034                                 --eval '(orphan-watchdog $$)'" || return
1035                 EMACS_SERVER="$server_name"
1036                 # wait until the emacs server is up
1037                 until test_emacs '()' >/dev/null 2>/dev/null; do
1038                         sleep 1
1039                 done
1040         fi
1041
1042         # Clear test-output output file.  Most Emacs tests end with a
1043         # call to (test-output).  If the test code fails with an
1044         # exception before this call, the output file won't get
1045         # updated.  Since we don't want to compare against an output
1046         # file from another test, so start out with an empty file.
1047         rm -f OUTPUT
1048         touch OUTPUT
1049
1050         ${TEST_EMACSCLIENT} --socket-name="$EMACS_SERVER" --eval "(progn $@)"
1051 }
1052
1053 test_python() {
1054         export LD_LIBRARY_PATH=$TEST_DIRECTORY/../lib
1055         export PYTHONPATH=$TEST_DIRECTORY/../bindings/python
1056
1057         # Some distros (e.g. Arch Linux) ship Python 2.* as /usr/bin/python2,
1058         # most others as /usr/bin/python. So first try python2, and fallback to
1059         # python if python2 doesn't exist.
1060         cmd=python2
1061         [[ ${test_missing_external_prereq_[python2]} == t ]] && cmd=python
1062
1063         (echo "import sys; _orig_stdout=sys.stdout; sys.stdout=open('OUTPUT', 'w')"; cat) \
1064                 | $cmd -
1065 }
1066
1067 # Creates a script that counts how much time it is executed and calls
1068 # notmuch.  $notmuch_counter_command is set to the path to the
1069 # generated script.  Use notmuch_counter_value() function to get the
1070 # current counter value.
1071 notmuch_counter_reset () {
1072         notmuch_counter_command="$TMP_DIRECTORY/notmuch_counter"
1073         if [ ! -x "$notmuch_counter_command" ]; then
1074                 notmuch_counter_state_path="$TMP_DIRECTORY/notmuch_counter.state"
1075                 cat >"$notmuch_counter_command" <<EOF || return
1076 #!/bin/sh
1077
1078 read count < "$notmuch_counter_state_path"
1079 echo \$((count + 1)) > "$notmuch_counter_state_path"
1080
1081 exec notmuch "\$@"
1082 EOF
1083                 chmod +x "$notmuch_counter_command" || return
1084         fi
1085
1086         echo 0 > "$notmuch_counter_state_path"
1087 }
1088
1089 # Returns the current notmuch counter value.
1090 notmuch_counter_value () {
1091         if [ -r "$notmuch_counter_state_path" ]; then
1092                 read count < "$notmuch_counter_state_path"
1093         else
1094                 count=0
1095         fi
1096         echo $count
1097 }
1098
1099 test_reset_state_ () {
1100         test -z "$test_init_done_" && test_init_
1101
1102         test_subtest_known_broken_=
1103         test_subtest_missing_external_prereq_=()
1104 }
1105
1106 # called once before the first subtest
1107 test_init_ () {
1108         test_init_done_=t
1109
1110         # skip all tests if there were external prerequisites missing during init
1111         test_check_missing_external_prereqs_ "all tests in $this_test" && test_done
1112 }
1113
1114
1115 . ./test-lib-common.sh
1116
1117 emacs_generate_script
1118
1119
1120 # Use -P to resolve symlinks in our working directory so that the cwd
1121 # in subprocesses like git equals our $PWD (for pathname comparisons).
1122 cd -P "$test" || error "Cannot setup test environment"
1123
1124 if test "$verbose" = "t"
1125 then
1126         exec 4>&2 3>&1
1127 else
1128         exec 4>test.output 3>&4
1129 fi
1130
1131 this_test=${0##*/}
1132 for skp in $NOTMUCH_SKIP_TESTS
1133 do
1134         to_skip=
1135         for skp in $NOTMUCH_SKIP_TESTS
1136         do
1137                 case "$this_test" in
1138                 $skp)
1139                         to_skip=t
1140                 esac
1141         done
1142         case "$to_skip" in
1143         t)
1144                 say_color skip >&3 "skipping test $this_test altogether"
1145                 say_color skip "skip all tests in $this_test"
1146                 test_done
1147         esac
1148 done
1149
1150 # Provide an implementation of the 'yes' utility
1151 yes () {
1152         if test $# = 0
1153         then
1154                 y=y
1155         else
1156                 y="$*"
1157         fi
1158
1159         while echo "$y"
1160         do
1161                 :
1162         done
1163 }
1164
1165 # Fix some commands on Windows
1166 case $(uname -s) in
1167 *MINGW*)
1168         # Windows has its own (incompatible) sort and find
1169         sort () {
1170                 /usr/bin/sort "$@"
1171         }
1172         find () {
1173                 /usr/bin/find "$@"
1174         }
1175         sum () {
1176                 md5sum "$@"
1177         }
1178         # git sees Windows-style pwd
1179         pwd () {
1180                 builtin pwd -W
1181         }
1182         # no POSIX permissions
1183         # backslashes in pathspec are converted to '/'
1184         # exec does not inherit the PID
1185         ;;
1186 *)
1187         test_set_prereq POSIXPERM
1188         test_set_prereq BSLASHPSPEC
1189         test_set_prereq EXECKEEPSPID
1190         ;;
1191 esac
1192
1193 test -z "$NO_PERL" && test_set_prereq PERL
1194 test -z "$NO_PYTHON" && test_set_prereq PYTHON
1195
1196 # test whether the filesystem supports symbolic links
1197 ln -s x y 2>/dev/null && test -h y 2>/dev/null && test_set_prereq SYMLINKS
1198 rm -f y
1199
1200 # declare prerequisites for external binaries used in tests
1201 test_declare_external_prereq dtach
1202 test_declare_external_prereq emacs
1203 test_declare_external_prereq ${TEST_EMACSCLIENT}
1204 test_declare_external_prereq gdb
1205 test_declare_external_prereq gpg
1206 test_declare_external_prereq python
1207 test_declare_external_prereq python2